%This function finds the gap in G3's support if there is any.

function [gaps3 G3 gaps3index]=findgaps(S, G3)
    n = length(S); %S, G3 are of length 'n+1' in calling function, here n
    gaps3 = 0;
    %find index of uppper boundary of G3 support S3
    S3_index=min(find(G3==1));
    for i=n+1-S3_index:n-1;
        %stop checking, no further values to check against at n
        if G3(n+1-i) < G3(n-i); %find first decreasing point
            [gap_val gap_l_index] = max(G3(1:n-i)); %trace back to prev max
            gap_h_index = n - i + find(G3(n+1-i:n)>=gap_val,1,'first'); %next reach prev max
            for j = gap_l_index+1:gap_h_index-1; %set in-between values
                G3(j) = gap_val;
            end;
            %keep a list of gaps
            if sum(gaps3) == 0;
                gaps3 = [S(gap_l_index) S(gap_h_index-1)];
                gaps3index = [(gap_l_index) (gap_h_index-1)];
            else
                gaps3 = cat(2, [S(gap_l_index) S(gap_h_index-1)], gaps3);
                gaps3index = cat(2, [(gap_l_index) (gap_h_index-1)], gaps3index);
            end;
        end;
    end;
    if(sum(gaps3)==0); gaps3index=0;end;%set index if no gaps
   return;
end